stages:
  - build draft
  - test
  - build final
  - silly

build draft:
  stage: build draft
  only:
    changes:
      - docker/draft/**/*
      - source/**/*
  image: docker:19.03.8
  services:
    - docker:19.03.8-dind
  script:
    - docker login --username gitlab-ci-token --password $CI_JOB_TOKEN $CI_REGISTRY
    - docker image pull $CI_REGISTRY_IMAGE:draft || true
    - >
      docker image build
      --pull
      --cache-from $CI_REGISTRY_IMAGE:draft
      --tag $CI_REGISTRY_IMAGE:draft
      --file docker/draft/Dockerfile
      .
    - docker image push $CI_REGISTRY_IMAGE:draft
    - docker logout $CI_REGISTRY

test:
  stage: test
  only:
    changes:
      - .env.draft
      - docker/draft/**/*
      - source/**/*
  image: registry.gitlab.com/daverona/templates/django:draft
  cache:
    key: $CI_COMMIT_REF_NAME
    paths:
      - source/.pip
  script:
    - cd source
    - pip install --cache-dir=.pip pytest-cov
    - echo -e "[pytest]\npython_files = tests.py test_*.py *_test.py" > pytest.ini
    - cp ../.env.draft .env
    - python3 manage.py makemigrations --no-input
    - python3 manage.py migrate --no-input
    - pytest --cov=. || ([ "$?" == "5" ] && true || false)

build final:
  stage: build final
  only:
    changes:
      - docker/final/**/*
      - source/**/*
  image: docker:19.03.8
  services:
    - docker:19.03.8-dind
  script:
    - docker login --username gitlab-ci-token --password $CI_JOB_TOKEN $CI_REGISTRY
    - docker image pull $CI_REGISTRY_IMAGE:final || true
    - >
      docker image build
      --pull
      --cache-from $CI_REGISTRY_IMAGE:final
      --tag $CI_REGISTRY_IMAGE:final
      --file docker/final/Dockerfile
      .
    - docker image push $CI_REGISTRY_IMAGE:final
    - docker image tag $CI_REGISTRY_IMAGE:final $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
    - docker image push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
    - docker logout $CI_REGISTRY

silly:
  stage: silly
  script:
    - echo "You silly."
